## pasdoc 0.16.0

=== Makefile ===
include Makefile-autodetect

#######################################################################
# BASE CONFIGURATION
#######################################################################

# The version of the package.
# This must be changed on each version change,
# as documented at https://github.com/pasdoc/pasdoc/wiki/ReleaseMaking .
VERSION := 0.16.0

# The name of the package / file name
PACKAGENAME := pasdoc

# Location of units source code.
UNIT_DIRS := ./source/component ./source/console \
  ./source/component/tipue

INCLUDE_DIRS := ./source/component ./source/component/images

# Base file to compile
FILE := ./source/console/pasdoc.dpr

# Base directory where binaries will go
ifndef BINDIR
BINDIR := bin
endif

# Base directory where libs, units, objects files will go
ifndef OUTDIR
OUTDIR := lib
endif

# The following is for creating the final package, comment out
# if that particular section is not used.
# BINFILES: Files that will go into the resulting bin directory
# DOCFILES: Files that will go into the resulting docs directory
BINFILES := $(BINDIR)/pasdoc$(EXE) \
	$(BINDIR)/pascal_pre_proc$(EXE) \
	$(BINDIR)/file_to_pascal_string$(EXE) \
	$(BINDIR)/file_to_pascal_data$(EXE)
DOCFILES := LICENSE ChangeLog.md README.md

PACKAGE_BASENAME := $(PACKAGENAME)-$(VERSION)-$(PACKAGE_BASENAME_SUFFIX)

############################################################################
# Variables below are *not* configurable, i.e. don't change them (unless
# you know what you're doing and you're able to accordingly change
# some rules later in this Makefile, that may depend on given variable's
# value).
############################################################################

PACKAGEDIR := $(PACKAGEBASEDIR)$(PATHSEP)$(PACKAGENAME)

############################################################################
# Change the paths to the correct types
#######################################################################

ifdef OUTDIR
OUTDIR := $(subst /,$(PATHSEP),$(OUTDIR))
endif
ifdef BINDIR
BINDIR := $(subst /,$(PATHSEP),$(BINDIR))
endif
FILE := $(subst /,$(PATHSEP),$(FILE))
UNIT_DIRS := $(subst /,$(PATHSEP),$(UNIT_DIRS))
INCLUDE_DIRS := $(subst /,$(PATHSEP),$(INCLUDE_DIRS))
ifdef BINFILES
BINFILES := $(subst /,$(PATHSEP),$(BINFILES))
endif
ifdef DOCFILES
DOCFILES := $(subst /,$(PATHSEP),$(DOCFILES))
endif

############################################################################
# FreePascal Configuration
############################################################################

# FPC_DEFAULT means "use current os and processor",
# calling just fpc binary on the path
FPC_DEFAULT := fpc

FPC_WIN32        := $(FPC_DEFAULT) -Pi386    -Twin32
FPC_WIN64        := $(FPC_DEFAULT) -Px86_64  -Twin64
FPC_GO32         := $(FPC_DEFAULT) -Pi386    -Tgo32v2
FPC_LINUX_X86    := $(FPC_DEFAULT) -Pi386    -Tlinux
FPC_LINUX_X86_64 := $(FPC_DEFAULT) -Px86_64  -Tlinux
FPC_LINUX_ARM    := $(FPC_DEFAULT) -Parm     -Tlinux
FPC_LINUX_M68K   := $(FPC_DEFAULT) -Pm68k    -Tlinux
FPC_LINUX_PPC    := $(FPC_DEFAULT) -Ppowerpc -Tlinux
FPC_AMIGA        := $(FPC_DEFAULT) -Pppc     -Tamiga
FPC_BEOS         := $(FPC_DEFAULT) -Pi386    -Tbeos
FPC_OS2          := $(FPC_DEFAULT) -Pi386    -Tos2
FPC_FREEBSD_X86  := $(FPC_DEFAULT) -Pi386    -Tfreebsd
FPC_DARWIN_X86   := $(FPC_DEFAULT) -Pi386    -Tdarwin
FPC_DARWIN_X86_64:= $(FPC_DEFAULT) -Px86_64  -Tdarwin

FPC_UNIT_DIRS := $(foreach units,$(UNIT_DIRS),-Fu$(units))
FPC_INCLUDE_DIRS := $(foreach units,$(INCLUDE_DIRS),-Fi$(units))

FPC_COMMON_FLAGS := -FE$(BINDIR) -FU$(OUTDIR) @pasdoc-fpc.cfg \
  $(FPC_UNIT_DIRS) $(FPC_INCLUDE_DIRS)

FPC_DEBUG_FLAGS := $(FPC_COMMON_FLAGS)
ifdef CHECK_MEM_LEAK
  FPC_DEBUG_FLAGS := -dCHECK_MEM_LEAK $(FPC_DEBUG_FLAGS)
endif

FPC_RELEASE_FLAGS := -dRELEASE $(FPC_COMMON_FLAGS)

############################################################################
# Delphi configuration
############################################################################

# Don't ask me why, but Borland named Delphi/Win32 command-line compiler
# dcc32 and Delphi/Linux (aka Kylix) as dcc (without 32).

DCC_WIN32 := dcc32
DCC_LINUX := dcc
DCC_UNIT_DIRS := $(foreach units,$(UNIT_DIRS),-U$(units))
DCC_INCLUDE_DIRS := $(foreach units,$(INCLUDE_DIRS),-I$(units))

# Command-line dcc prints non-errorlines while it works,
# I guess that it was meant to somehow indicate
# compilation progress, although it's rather confusing and hides
# meaningfull error/warning lines. That's why we pass -Q below.

DCC_COMMON_FLAGS := -E$(BINDIR) -N$(OUTDIR) -L$(OUTDIR) -M -H -W -Q \
  -DCPU86 -DENDIAN_LITTLE $(DCC_UNIT_DIRS) $(DCC_INCLUDE_DIRS)

DCC_DEBUG_FLAGS := -$$Q+ -$$R+ $(DCC_COMMON_FLAGS)

DCC_RELEASE_FLAGS := -$$O+ $(DCC_COMMON_FLAGS)

############################################################################
# Building (and cleaning after building)
############################################################################

# Default target
.PHONY: default
default: build-fpc-default-debug

# Clean up the output files.
.PHONY: clean
clean:
	rm -Rf source/console/pasdoc.compiled \
	       source/packages/lazarus/lib/ \
	       source/gui/pasdoc_gui.compiled \
	       source/gui/pasdoc_gui \
	       source/gui/pasdoc_gui.exe \
	       source/gui/pasdoc_gui.app \
	       source/gui/*.o \
	       source/gui/*.or \
	       source/gui/*.ppu \
	       source/gui/*.res
	$(MAKE) clean -C tests/
	$(MAKE) clean -C source/autodoc/
ifdef OUTDIR
	rm -Rf $(OUTDIR)
	mkdir $(OUTDIR)
	touch $(OUTDIR)/.gitkeep
endif
ifdef BINDIR
	rm -Rf $(BINDIR)
endif

# Make sure that $(BINDIR) and $(OUTDIR) exist, create them if necessary.
# This is executed before executing any `build-xxx' target,
# to make sure that compilation works "out of the box".
#
# Always using special directories for $(BINDIR) and $(OUTDIR) is handy
# -- reduces clutter, allows us to easily write `clean' target.
#
# Note that, unless you override $(BINDIR) and $(OUTDIR) at command-line,
# they don't really help you when you have various compilers, for
# various os/arch etc. because $(BINDIR) and $(OUTDIR) are always the same
# anyway, so all compilers reuse the same dirs... In the future various
# build-<compiler>-<os/arch> targets may be tweaked to use different
# $(BINDIR) and $(OUTDIR).
.PHONY: make-dirs
make-dirs:
ifdef OUTDIR
	$(MKDIRPROG) -p $(OUTDIR)
endif
ifdef BINDIR
	$(MKDIRPROG) -p $(BINDIR)
endif

# fpc- build targets

.PHONY: build-fpc-default-debug
build-fpc-default-debug: make-dirs
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) $(FILE)

.PHONY: build-fpc-default
build-fpc-default: make-dirs
	$(FPC_DEFAULT) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-win32
build-fpc-win32: make-dirs
	$(FPC_WIN32) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-win64
build-fpc-win64: make-dirs
	$(FPC_WIN64) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-go32
build-fpc-go32: make-dirs
	$(FPC_GO32) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-linux-x86
build-fpc-linux-x86: make-dirs
	$(FPC_LINUX_X86) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-linux-x86_64
build-fpc-linux-x86_64: make-dirs
	$(FPC_LINUX_X86_64) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-linux-arm
build-fpc-linux-arm: make-dirs
	$(FPC_LINUX_ARM) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-linux-m68k
build-fpc-linux-m68k: make-dirs
	$(FPC_LINUX_M68K) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-amiga
build-fpc-amiga: make-dirs
	$(FPC_AMIGA) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-beos
build-fpc-beos: make-dirs
	$(FPC_BEOS) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-os2
build-fpc-os2: make-dirs
	$(FPC_OS2) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-linux-ppc
build-fpc-linux-ppc: make-dirs
	$(FPC_LINUX_PPC) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-freebsd-x86
build-fpc-freebsd-x86: make-dirs
	$(FPC_FREEBSD_X86) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-darwin-x86
build-fpc-darwin-x86: make-dirs
	$(FPC_DARWIN_X86) $(FPC_RELEASE_FLAGS) $(FILE)

.PHONY: build-fpc-darwin-x86_64
build-fpc-darwin-x86_64: make-dirs
	$(FPC_DARWIN_X86_64) $(FPC_RELEASE_FLAGS) $(FILE)

# Delphi/Kylix build targets

# Implementation note: this $(subst...) is needed, otherwise under Windows
# dcc dumbly prints "file not found" when $(FILE) uses "/" (yes, "/" is allowed
# path separator in all normal Windows programs...) (and $(FILE) uses
# "/" because this is sensible default value for $(PATHSEP), otherwise we would
# have to do dirty checks to guess whether we're used under Unix or Win32 in
# this Makefile).
.PHONY: build-delphi-win32
build-delphi-win32: make-dirs
	$(DCC_WIN32) $(DCC_RELEASE_FLAGS) $(subst $(PATHSEP),\\,$(FILE))

.PHONY: build-delphi-linux-x86
build-delphi-linux-x86: make-dirs
	$(DCC_LINUX) $(DCC_RELEASE_FLAGS) $(FILE)

# obsolete target
.PHONY: build-pascal_pre_proc
build-pascal_pre_proc: make-dirs
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/pascal_pre_proc.dpr

.PHONY: build-tools
build-tools: make-dirs
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/pascal_pre_proc.dpr
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/file_to_pascal_data.dpr
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./source/tools/file_to_pascal_string.dpr

.PHONY: build-gui
build-gui:
	lazbuild $(LAZBUILD_OPTIONS) source/packages/lazarus/pasdoc_package.lpk
	lazbuild $(LAZBUILD_OPTIONS) source/gui/pasdoc_gui.lpi
	strip source/gui/pasdoc_gui$(EXE)

.PHONY: tests-fpcunit
tests-fpcunit: make-dirs
	$(FPC_DEFAULT) $(FPC_DEBUG_FLAGS) ./tests/fpcunit/test_pasdoc.lpr
	bin/test_pasdoc -a

.PHONY: tests
tests:
	cd tests/ && ./run_all_tests.sh

############################################################################
# Help targets
############################################################################

.PHONY: help
help:
	@echo "Available targets of this Makefile:"
	@echo
	@echo "Compiling:"
	@echo
	@echo "  default, build-fpc-default-debug:"
	@echo "    Compile debug version with FPC. This is the default target."
	@echo
	@echo "  build-fpc-default:"
	@echo "    Compile release version with FPC."
	@echo
	@echo "  build-<compiler>-<os/arch>:"
	@echo "    Compile release version with given compiler for given OS"
	@echo "    and architecture. Available values for <compiler> are:"
	@echo "      fpc"
	@echo "      delphi"
	@echo "    Available values for <os/arch> are:"
	@echo "      win32"
	@echo "      win64"
	@echo "      go32"
	@echo "      linux-x86"
	@echo "      linux-x86_64"
	@echo "      linux-m68k"
	@echo "      linux-arm"
	@echo "      amiga"
	@echo "      beos"
	@echo "      os2"
	@echo "      linux-ppc"
	@echo "      freebsd-x86"
	@echo "      darwin-x86"
	@echo "      darwin-x86_64"
	@echo "    Of course, not all combinations of <compiler> and <os/arch>"
	@echo "    are available..."
	@echo
	@echo "    Note that in case of FPC, these targets assume that variable"
	@echo "    FPC_<os/arch> points to a compiler that produces"
	@echo "    a binary for given <os/arch>. So if you want to cross-compile"
	@echo "    with FPC, make sure to adjust these variables accordingly."
	@echo
	@echo "  build-gui:"
	@echo "    Compile pasdoc_gui with lazbuild (Lazarus build tool)."
	@echo
	@echo "  clean:"
	@echo "    Clean files produced during compilation."
	@echo
	@echo "Archiving a release:"
	@echo
	@echo "  dist-<os/arch>:"
	@echo "    This calls \"clean\", then \"build-<compiler>-<os/arch>\""
	@echo "    (using the preferred <compiler> for making a release on"
	@echo "    this <os/arch> -- currently, always FPC)"
	@echo "    and then makes a release archive for given <os/arch>."
	@echo
	@echo "  dist-src:"
	@echo "    This creates source archive for the current sources."

.PHONY: version
version:
	@echo $(VERSION)

.PHONY: tag
tag:
	git log --pretty=oneline HEAD^..HEAD
	git tag -a v$(VERSION) -m "Tagging the $(VERSION) version of PasDoc."
	git push origin --tags

############################################################################
# Targets to make release archives
#
# Some general targets are present here, and targets

=== old_docs/Makefile ===
default:
	@echo 'No default target defined in this Makefile'

clean:
	rm -f pasdoc.aux pasdoc.log pasdoc.toc pasdoc.dvi

=== tests/Makefile ===
.PHONY: default
default:
	./run_all_tests.sh

.PHONY: validate_html
validate_html:
	scripts/validate_html.sh

.PHONY: validate_simplexml
validate_simplexml:
	scripts/validate_simplexml.sh

.PHONY: clean
clean:
	rm -Rf \
	  scripts/check_cache_tmp/ \
	  scripts/upload_correct_tests_output_tmp/

=== source/autodoc/Makefile ===
# This Makefile creates PasDoc generated documentation for PasDoc itself.
# Documentation is created in subdirectories named after pasdoc's --format
# names (html/, latex/ etc.)
#
# Targets:
#
#   html latex pdf dvi ps html-latex htmlhelp rtf
#     Make documentation in requested format.
#
#   clean
#     Delete all generated documentation.
#
#   public
#     Generate documentation in all formats that we want to show
#     on https://pasdoc.github.io/autodoc/ .
#
#   upload
#     Copy documentation generated by `public'
#     to ../../../pasdoc.github.io/docs/ .
#     This assumes you have cloned
#     https://github.com/pasdoc/pasdoc.github.io alongside pasdoc repo.
#     After pushing this repo it will be visible on
#     https://pasdoc.github.io/autodoc/ .
#
# Some hints:
#   To completely remake all documentation for
#   https://pasdoc.github.io/autodoc/
#   just call `make clean public upload'
#   then in ../../../pasdoc.github.io/ to GIT commit + push with new docs.

# Making documentation ----------------------------------------

# Name of pasdoc binary. Remember that you can override it at
# make's command-line, like `make PASDOC=my_pasdoc'
PASDOC=pasdoc

# These options will be passed to every pasdoc invocation,
# i.e. for every output format.
PASDOC_OPTIONS=--include ../component \
  ../component/*.pas ../component/tipue/*.pas \
  ../console/*.pas \
  -DFPC -DVER2 -DPASDOC \
  --title "PasDoc's autodoc" --write-uses-list  --auto-abstract \
  --introduction=introduction.txt

GRAPHVIZ_COMMANDS=dot -Grankdir=LR -Tjpg -oGVClasses.jpg GVClasses.dot; \
                  dot -Grankdir=LR -Tjpg -oGVUses.jpg GVUses.dot

# These options will be passed only when making docs in format that
# supports including graphviz graphs.
PASDOC_GRAPHVIZ_OPTIONS=--graphviz-classes --graphviz-uses \
  --link-gv-classes jpg --link-gv-uses jpg

# How to call hhc (html help compiler) ?
# Default value means that it must be available on path.
# As usual, remember you can override it at make's command-line.
HHC=hhc

.PHONY: html latex pdf dvi ps html-latex clean htmlhelp rtf

html:
	mkdir -p html/
	$(PASDOC) $(PASDOC_OPTIONS) $(PASDOC_GRAPHVIZ_OPTIONS) \
	  --output=html/ --use-tipue-search
	cd html/; $(GRAPHVIZ_COMMANDS)

# Ignore exit code from hhc (it's always 1 ???)
htmlhelp:
	mkdir -p htmlhelp/
	$(PASDOC) $(PASDOC_OPTIONS) $(PASDOC_GRAPHVIZ_OPTIONS) \
	  --format=htmlhelp --output=htmlhelp/
	cd htmlhelp/; $(GRAPHVIZ_COMMANDS)
	-cd htmlhelp/; $(HHC) docs.hhp

# Just shortcuts
latex: latex/docs.tex
pdf: latex/docs.pdf
dvi: latex/docs.dvi
ps: latex/docs.ps
html-latex: latex/docs.html
rtf: latex2rtf/docs.rtf

latex/docs.tex:
	mkdir -p latex/
	$(PASDOC) $(PASDOC_OPTIONS) \
	  --format=latex --output=latex/

# (Yes, I must do `cd latex' before calling pdflatex, I can't simply call
# `pdflatex latex/docs.tex' because then many output files of pdflatex
# would be placed in current dir)
latex/docs.pdf: latex/docs.tex
	cd latex; pdflatex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex; pdflatex --file-line-error-style -interaction=nonstopmode docs.tex

latex/docs.dvi: latex/docs.tex
	cd latex; latex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex; latex --file-line-error-style -interaction=nonstopmode docs.tex

latex/docs.ps: latex/docs.dvi
	cd latex; dvips docs.dvi -o docs.ps

# When working htlatex overrides latex/docs.dvi with a version
# that is not really a useful to browse (it's only for htlatex internals).
# That's why I `rm' it afterwards.
#
# As far as I understand how htlatex works, it's not needed to run
# htlatex twice (like it's needed with pdflatex and latex).
latex/docs.html: latex/docs.tex
	cd latex; htlatex docs.tex
	rm latex/docs.dvi

latex2rtf/docs.tex:
	mkdir -p latex2rtf/
	$(PASDOC) $(PASDOC_OPTIONS) \
	  --format=latex2rtf --output=latex2rtf/

# I must have latex/docs.tex as a prerequisite, to run latex over it
# to generate docs.aux file. Then I can use latex/docs.aux file with latex2rtf
# so that latex2rtf can make appropriate links.
latex2rtf/docs.rtf: latex2rtf/docs.tex latex/docs.tex
	cd latex/; latex --file-line-error-style -interaction=nonstopmode docs.tex
	cd latex2rtf/; latex2rtf -a ../latex/docs.aux docs.tex

clean:
	rm -Rf html/ latex/ latex2rtf/ htmlhelp/ html_by_pasdoc_gui/

# ------------------------------------------------------------
# Making and uploading autodoc for https://pasdoc.github.io/autodoc/

.PHONY:	public upload

public: html pdf latex

OUTPUT_DIR:=../../../pasdoc.github.io/docs/
AUTODOC_DIR:=$(OUTPUT_DIR)autodoc/

upload:
	rm -Rf $(AUTODOC_DIR)
	mkdir -p $(AUTODOC_DIR) $(AUTODOC_DIR)latex/
	cp -Rf html/ $(AUTODOC_DIR)
	cp -Rf latex/docs.pdf $(AUTODOC_DIR)latex/
	cp -Rf latex/docs.tex $(AUTODOC_DIR)latex/

# eof ------------------------------------------------------------

=== source/component/images/Makefile ===
# Generate all *.gif.inc files from *.gif files in this directory.
# Uses ../../tools/file_to_pascal_data program, so be sure that it's
# compiled.

ALL_OUTPUT := automated.gif.inc \
  private.gif.inc \
  protected.gif.inc \
  public.gif.inc \
  published.gif.inc

.PHONY: all clean

all: $(ALL_OUTPUT)

clean:
	rm -f $(ALL_OUTPUT)

%.gif.inc: %.gif
	../../../bin/file_to_pascal_data $< $@

=== source/component/lang/Makefile ===
# Generate automatic translation files (convert encodings).
# The plan is to automatically make here as much as possible.

ALL_OUTPUT := PasDoc_Languages_Czech_1250.inc

.PHONY: all clean
all: $(ALL_OUTPUT)
clean:
	rm -f $(ALL_OUTPUT)

PasDoc_Languages_Czech_1250.inc: PasDoc_Languages_Czech_iso_8859_2.inc
	iconv --from ISO_8859-2 --to WINDOWS-1250 < $< > $@

=== source/component/tipue/Makefile ===
# Generates all *.inc files from text/binary files in this directory.

ALL_OUTPUT := tipuesearch.css.inc tipuesearch.js.inc \
  tipuesearch_set.js.inc tipue_results.html.inc \
  search.png.inc loader.gif.inc jquery.min.js.inc

.PHONY: all clean

all: $(ALL_OUTPUT)

tipue_results.html.inc: tipue_results.html
	../../../bin/file_to_pascal_string $< $@

# We use file_to_pascal_data even for text files, to workaround
# Delphi problems with long strings, see
# https://sourceforge.net/p/pasdoc/bugs/82/

%.inc: %
	../../../bin/file_to_pascal_data $< $@

clean:
	rm -f $(ALL_OUTPUT)

=== debian/changelog ===
pasdoc (0.16.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    See-also: https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html
  * Update standards version to 4.5.1, no changes needed.
    Changes-By: lintian-brush
    Fixes: lintian: out-of-date-standards-version
    See-also: https://lintian.debian.org/tags/out-of-date-standards-version.html

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 01 Nov 2021 11:28:55 +0100

pasdoc (0.16.0-1) experimental; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Repository.

  [ Abou Al Montacir ]
  * Fixed watch file after upstream URL changed.
  * New upstream version 0.16.0
  * Removed patches integrated by upstream.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 10 Apr 2021 17:49:06 +0200

=== debian/control ===
Source: pasdoc
Section: doc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders: Paul Gevers <elbrus@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
 fp-compiler,
 fp-units-fcl,
 graphviz,
 help2man,
 latex2html,
 libjs-jquery,
 libxml2-utils,
 opensp,
 texlive-latex-base
Standards-Version: 4.5.1
Homepage: https://github.com/pasdoc/pasdoc/wiki
Vcs-Browser: https://salsa.debian.org/pascal-team/pasdoc
Vcs-Git: https://salsa.debian.org/pascal-team/pasdoc.git

Package: pasdoc
Architecture: any
Depends: ${misc:Depends},
Description: documentation tool for Pascal source code
 Pasdoc generates documentation for Pascal units. It takes descriptions from
 comments within the source code. Documentation output formats include HTML and
 LaTeX. Object Pascal, FreePascal and Delphi specific features are supported.
 .
 Pasdoc has the follow features:
  * Understands code written in any Pascal and Object Pascal dialect
  * Understands modern Object Pascal language, as found in latest FreePascal
    and Delphi versions
  * Many output formats: HTML, HTMLHelp, LaTeX (PDF, PS), latex2rft, XML
  * Command-line (in batch mode) and GUI interface
  * Documentation from comments in the source code and/or provided in separate
    file
  * Arbitrary (even optional) comment markers
  * Special @-tags for formatting the documentation
  * Whole pages (like introduction to the docs) can be written using @-tags
  * Easy search box in HTML output using Tipue
  * Classes and unit dependency graphs
  * Optional automatic linking of identifiers
  * Spell checking
  * Cache for generating documentation fast

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export USE_DIFF_TO_COMPARE=true

# the newly created binary is needed for the test-suite, so put it on the path
# I actually only want to do this while running the test-suite, but I can't
# figure out how to do that in a Makefile
export PATH:=${PATH}:$(shell pwd)/bin

%:
	dh ${@}

override_dh_auto_clean:
	dh_auto_clean
	make -C tests clean
	# I wish I could clean source/component here, but then the build-tools
	# target FTBFS, so clean in the override_dh_auto_build target instead.
#	make -C source/component clean
	make -C source/component/images clean
	make -C source/component/tipue clean

override_dh_auto_configure:
	ln -s /usr/share/javascript/jquery/jquery.js     source/component/tipue/
	ln -s /usr/share/javascript/jquery/jquery.min.js source/component/tipue/
	dh_auto_configure

override_dh_auto_build:
	# Make sure we regenerate all the generated *.inc files. Unfortunately, we
	# need two binaries that FTBFS without the *.inc files to start with.
	make build-tools
	make -C source/component clean all
	make -C source/component/images all
	make -C source/component/tipue all
	dh_auto_build

	# Use the help from the binary to create a man page as none is supplied.
	help2man --output=pasdoc.1 --name="documentation tool for Pascal source code" \
		 --no-info bin/pasdoc

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd tests && ./run_all_tests.sh
endif

=== debian/watch ===
version=4
opts=\
compression=xz,\
repack,\
repacksuffix=+dfsg,\
uversionmangle=s/-/~/,\
dversionmangle=s/\+dfsg(\d*)//,\
"filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pasdoc-$1.tar.xz%" \
	https://github.com/pasdoc/pasdoc/tags \
	(?:.*?/)?v?@ANY_VERSION@\.tar\.gz debian
